=== debian/changelog ===
ga (5.8.1-5) unstable; urgency=medium

  * Team upload.
  * rebuild against scalapack 2.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 07 Mar 2022 23:15:06 +0100

ga (5.8.1-4) unstable; urgency=medium

  * Team upload.
  * restore Build-Depends: libblas-dev. Linking against generic BLAS
    required to enable run-time execution against alternative
    optimized BLAS implementations (openblas, blis, atlas, etc)
  * likewise Build-Depends: liblapack-dev to link against generic LAPACK
    Install optimized library (openblas etc) for end-user execution.

 -- Drew Parsons <dparsons@debian.org>  Thu, 03 Mar 2022 11:57:46 +0100

ga (5.8.1-3) unstable; urgency=medium

  * Team upload.
  * install ga-config specific to each MPI flavour under /usr/lib
    and set /usr/bin/ga-config as a symlink to the default MPI.
  * update debian patch build_mpi_flavor.patch to apply MPI_FLAVOR to
    -lga and -larmci references in ga-config

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Mar 2022 23:08:18 +0100

ga (5.8.1-2) unstable; urgency=medium

  * Team upload.
  * build static libraries for both OpenMPI and MPICH
    - Build-Depends: libarmci-mpi-dev (>= 0.3.1~beta-2),
      libscalapack-openmpi-dev, libscalapack-mpich-dev,
      libopenmpi-dev, libmpich-dev
  * make MPI-specific build using MPI_FLAVOR as library name suffix
    (set with ./configure)
    - debian patch build_mpi_flavor.patch applies MPI_FLAVOR to
      automake files
    - build in subdir for each MPI flavor

 -- Drew Parsons <dparsons@debian.org>  Thu, 24 Feb 2022 13:16:05 +0100

ga (5.8.1-1) unstable; urgency=medium

  * Team upload.

  [ Drew Parsons ]
  * update debian/watch to watch releases/download links not tags
    (see https://github.com/GlobalArrays/ga/pull/240)
  * New upstream release.
  * provide a simple man page for ga-config (generated by help2man)
  * update debian/upstream/metadata to use Other-References not Homepage
    (see https://wiki.debian.org/UpstreamMetadata)
    Add Repository fields pointing to upstream github repo.
  * remove duplicate reference to armci/src/xfer/caccumulate.c in
    debian/copyright
  * Standards-Version: 4.6.0
  * debhelper compatibility level 13
    - mark uninstalled *.x and *.la files in debian/not-installed
  * configure with default path for armci to improve build
    reproducibility. Thanks Simon McVittie. Closes: #993674.

 -- Drew Parsons <dparsons@debian.org>  Sun, 13 Feb 2022 23:12:40 +0100

ga (5.8-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches/fix_comex_testsuite.patch: Refreshed.
  * debian/patches/testsuite_log_compiler.patch: Likewise.
  * debian/copyright: Removed no longer needed sections.

 -- Michael Banck <mbanck@debian.org>  Sat, 01 Jan 2022 14:53:00 +0100
