=== debian/control ===
Source: ga
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: debhelper-compat (= 13),
               gfortran,
               libarmci-mpi-dev (>= 0.3.1~beta-2),
               libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
               libscalapack-mpi-dev (>= 2),
               libscalapack-openmpi-dev (>= 2),
               libscalapack-mpich-dev (>= 2),
               mpi-default-dev,
               libopenmpi-dev, libmpich-dev,
               openssh-client
Standards-Version: 4.6.0
Homepage: http://hpc.pnl.gov/globalarrays/
Vcs-Browser: https://salsa.debian.org/debichem-team/ga
Vcs-Git: https://salsa.debian.org/debichem-team/ga.git

Package: libglobalarrays-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libga-dev (<< 5.4~beta~r10636+dfsg-3)
Breaks: libga-dev (<< 5.4~beta~r10636+dfsg-3)
Multi-Arch: no
Description: Distributed Shared-Memory Programming Environment (development)
 Global Arrays is a portable Non-Uniform Memory Access (NUMA) shared-memory
 programming environment for distributed and shared memory computers. It
 augments the message-passing model by providing a shared-memory like access to
 distributed dense arrays.
 .
 ARMCI provides one-sided remote memory operations used by GA.
 .
 ComEx (Communication Runtime for Extreme Scale) provides vector and strided
 interfaces to optimize performance of remote memory copy operations for
 non-contiguous data.  
 .
 DRA (Disk Resident Arrays) is a parallel I/O library that maintains dense 2-dim
 arrays on disk.
 .
 SF (Shared Files) is a parallel I/O library that allows noncollective I/O to a
 parallel file.
 .
 EAF (Exclusive Access Files) is parallel I/O library that supports I/O to
 private files.
 .
 TCGMSG is a simple, efficient, but becoming obsolete message-passing library.
 .
 TCGMSG-MPI is a TCGMSG interface implementation on top of MPI and ARMCI.
 .
 MA is a dynamic memory allocator/manager for Fortran and C programs.
 .
 GA++ is a C++ binding for global arrays.
 .
 This package contains the static libraries and header files.
 Static libraries are provided for both OpenMPI and MPICH.
