=== debian/watch ===
version=4
 https://github.com/GlobalArrays/ga/releases \
 (?:.*?)/download/(?:.*?/)ga-@ANY_VERSION@@ARCHIVE_EXT@
