=== debian/changelog ===
ga (5.8.2-3) unstable; urgency=medium

  * Team upload.
  * debian patch dsygv_int32_PR317.patch applies upstream PR#317 to
    ensure 32-bit integers are passed to dsygv. Needed in particular
    for big-endian architectures.

 -- Drew Parsons <dparsons@debian.org>  Sun, 05 Nov 2023 19:34:56 +0100

ga (5.8.2-2) unstable; urgency=medium

  * Team upload.
  * debian patch scalapack_32bit_PR315.patch applies upstream PR#315 to
    fix scalapack handling with 32 bit integers
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Oct 2023 00:55:44 +0100

ga (5.8.2-1) unstable; urgency=medium

  * Team upload.
  * update debian/watch to latest github format
  * New upstream release.
    - fixes tcgi pointer handling. Closes: #820677.
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Wed, 23 Nov 2022 17:48:18 +0100
