=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
                mpi-default-dev,
                libopenmpi-dev, libmpich-dev,
                openssh-client
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: http://hpc.pnl.gov/globalarrays/
 Vcs-Browser: https://salsa.debian.org/debichem-team/ga
 Vcs-Git: https://salsa.debian.org/debichem-team/ga.git
