=== debian/rules ===
#!/usr/bin/make -f

CFLAGS=-g -O2

export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/mpi-default-dev/debian_defaults

%:
	dh $@ --with autoreconf

override_dh_clean:
	dh_clean
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi

execute_after_dh_autoreconf:
	rm -rf $(CURDIR)/pristine-src $(CURDIR)/build-mpich $(CURDIR)/build-openmpi
	tmpdir=`mktemp -d`; \
	cp -ra $(CURDIR)/* $${tmpdir}; \
	mv $$tmpdir $(CURDIR)/pristine-src
	cp -ra pristine-src build-mpich
	cp -ra pristine-src build-openmpi

override_dh_auto_configure:
	for mpi_flavor in mpich openmpi; do \
		MPICC=mpicc.$${mpi_flavor} \
		MPICXX=mpicxx.$${mpi_flavor} \
		MPIF77=mpif77.$${mpi_flavor} \
		MPIFC=mpifort.$${mpi_flavor} \
		MPIF90=mpif90.$${mpi_flavor} \
		LDFLAGS="$${LDFLAGS} -pthread" \
		MPIEXEC="mpiexec.$${mpi_flavor} -np %NP%" \
		dh_auto_configure --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} -- \
		--enable-cxx 				\
		--with-tcgmsg				\
		--with-scalapack="-lscalapack-$${mpi_flavor}" \
		--with-blas4=-lblas			\
		--with-lapack=-llapack			\
		--with-mpi				\
		--with-armci=-larmci-$${mpi_flavor}	\
		MPI_FLAVOR=$${mpi_flavor};		\
	done

override_dh_auto_build:
	for mpi_flavor in mpich openmpi; do \
	  dh_auto_build --sourcedirectory=$(CURDIR)/build-$${mpi_flavor}; \
	done

override_dh_auto_install:
	for mpi_flavor in mpich openmpi; do \
	  dh_auto_install --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} --destdir=$(CURDIR)/debian/tmp; \
	done
	rm -f $(CURDIR)/debian/tmp/usr/include/error.h
	rm -f $(CURDIR)/debian/tmp/usr/include/memcpy.h
	rm -f $(CURDIR)/debian/tmp/usr/include/scope.h
	rm -f $(CURDIR)/debian/tmp/usr/include/string-util.h
	rm -f $(CURDIR)/debian/tmp/usr/include/table.h
	
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	-for mpi_flavor in mpich openmpi; do \
		dh_auto_test --sourcedirectory=$(CURDIR)/build-$${mpi_flavor} -- -j1 -k ARMCI_USE_WIN_ALLOCATE=1 MPIEXEC="mpiexec.$${mpi_flavor} -np 4"; \
	done
endif

override_dh_link:
	dh_link -plibglobalarrays-dev usr/lib/$(DEB_HOST_MULTIARCH)/libga-$(ARCH_DEFAULT_MPI_IMPL).a usr/lib/$(DEB_HOST_MULTIARCH)/libga.a
	dh_link -plibglobalarrays-dev usr/lib/$(DEB_HOST_MULTIARCH)/libga++-$(ARCH_DEFAULT_MPI_IMPL).a usr/lib/$(DEB_HOST_MULTIARCH)/libga++.a
	dh_link -plibglobalarrays-dev usr/lib/$(DEB_HOST_MULTIARCH)/ga/$(ARCH_DEFAULT_MPI_IMPL)/bin/ga-config  usr/bin/ga-config
