## ga 5.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -41,6 +41,7 @@
 
 ga_option(ENABLE_CXX ON)
 ga_option(ENABLE_FORTRAN ON)
+ga_option(ENABLE_COVERAGE OFF)
 ga_option(CMAKE_CXX_EXTENSIONS OFF)
 
 set(NOFORT 1)
@@ -60,6 +61,7 @@
 ga_option(LINALG_VENDOR BLIS)
 ga_option(ENABLE_TESTS ON)
 ga_option(ENABLE_PROFILING OFF)
+ga_option(ENABLE_SYSV OFF)
 #Options for user provided LinAlg libraries
 ga_option(ENABLE_BLAS OFF)
 ga_option(ENABLE_SCALAPACK OFF)
@@ -80,8 +82,15 @@
   endif()  
 endif()
 
-if(MSVC AND ENABLE_FORTRAN)
-  message(FATAL_ERROR "MSVC build needs ENABLE_FORTRAN=OFF")
+if(ENABLE_FORTRAN)
+  if(MSVC)
+    message(FATAL_ERROR "MSVC build needs ENABLE_FORTRAN=OFF")
+  endif()
+
+  find_program(ga_m4_cmd NAMES gm4 m4)
+  if(NOT ga_m4_cmd)
+    message(FATAL_ERROR "m4 command not found. GNU M4 is required.")
+  endif()
 endif()
 
 if(ENABLE_PROFILING)
@@ -115,7 +124,23 @@
 message(STATUS "Checking MPI ...")
 find_package (MPI REQUIRED)
 set(GA_EXTRA_LIBS ${GA_EXTRA_LIBS} MPI::MPI_C)
+
+if(ENABLE_COVERAGE)
+  add_compile_options(--coverage)
+  list(APPEND GA_EXTRA_LIBS --coverage)
+endif()
+
 if(ENABLE_FORTRAN)
+  #macos fix for clang+gfortran build
+  #linking MPI::MPI_Fortran adds the flag to clang compile line
+  if (CMAKE_Fortran_COMPILER_ID MATCHES "GNU")
+    get_target_property(_mpif_ico MPI::MPI_Fortran INTERFACE_COMPILE_OPTIONS)
+    if(_mpif_ico)
+      string(REPLACE "-fallow-argument-mismatch" "" _mpif_ico ${_mpif_ico})
+      separate_arguments(_mpif_ico)
+      set_target_properties(MPI::MPI_Fortran PROPERTIES INTERFACE_COMPILE_OPTIONS "${_mpif_ico}")
+    endif()
+  endif()
   list(APPEND GA_EXTRA_LIBS MPI::MPI_Fortran)
 endif()
 
@@ -123,7 +148,20 @@
 
 if (ENABLE_FORTRAN)
   include( FortranCInterface )
-  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h MACRO_NAMESPACE F77_FUNC_)
+  FortranCInterface_HEADER(${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.ignore MACRO_NAMESPACE F77_FUNC_)
+  add_custom_command(
+    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h
+    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.ignore" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake 
+    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.ignore
+  )
+  add_custom_target(
+    GenerateF2C_CH ALL
+    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h
+  )
+  set_source_files_properties(
+    ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h
+    PROPERTIES GENERATED TRUE
+  )
 else()
   CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/f2c_dummy.h.in
                   ${CMAKE_CURRENT_BINARY_DIR}/f2c_cmake.h )
@@ -137,7 +175,6 @@
 # hardwire various GA configuration parameters. Use convention that parameters
 # are defined and set to 0 if not used
 set (CYGWIN 0)
-set (DECOSF 0)
 
 if (CMAKE_SYSTEM_NAME STREQUAL Linux)
   set(LINUX 1)
@@ -170,7 +207,7 @@
 endif()
 if(USE_CRAYSHASTA)
   set(__CRAYXE 1)
-  list(APPEND GA_EXTRA_LIBS pmi2)
+  # list(APPEND GA_EXTRA_LIBS pmi2)
 endif()
 
 # hardwire ARMCI configuration options
@@ -199,7 +236,7 @@
      set (FORTRAN_I8_FLAG -fdefault-integer-8)
      set (FORTRAN_I4_FLAG "")
   elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Flang")
-     message(STATUS "Using Flang compiler settings")
+     message(STATUS "Using Flang compiler settings for flang, flang-new, armflang")
      set (F77_GETARG_DECLS "external GETARG")
      set (FORTRAN_I8_FLAG -fdefault-integer-8)
      set (FORTRAN_I4_FLAG "")
@@ -216,7 +253,15 @@
      message(STATUS "Using IBM XL Fortran compiler settings")
      set (FORTRAN_I8_FLAG -qintsize=8)
      set (FORTRAN_I4_FLAG -qintsize=4)
-  endif()
+  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Fujitsu")
+     message(STATUS "Fujitsu Fortran compiler settings")
+     set (FORTRAN_I8_FLAG "-CcdII8 -CcdLL8")
+     set (FORTRAN_I4_FLAG "")
+  elseif (CMAKE_Fortran_COMPILER_ID MATCHES "Cray")
+     message(STATUS "Cray Fortran compiler settings")
+     set (FORTRAN_I8_FLAG "-default64")
+     set (FORTRAN_I4_FLAG "")     
+  endif() 
 else()
 # need to set these variable even if only compiling C/C++
    set (F77_GETARG GETARG)
@@ -232,8 +277,25 @@
 # if(_fam_flag_exists)
 #   set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
 # endif()
-if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "10.1")
-  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
+if(CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
+  if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "10.1")
+    set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fallow-argument-mismatch")
+  endif()
+  if(CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL "11.1")
+    set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-tree-slp-vectorize")
+  endif()
+endif()
+
+if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  if(ENABLE_CXX) 
+    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+      add_compile_options(-fno-aggressive-loop-optimizations)
+    endif()
+  else()
+    add_compile_options(-fno-aggressive-loop-optimizations)
+  endif()  
+elseif (CMAKE_Fortran_COMPILER_ID STREQUAL "GNU")
+  set (CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fno-aggressive-loop-optimizations")
 endif()
 
 # Hardwire these settings. No way to check for Fortran integer size in CMake
@@ -256,9 +318,9 @@
   if (CMAKE_SYSTEM_NAME STREQUAL "Linux")
     set(NOUSE_MMAP 1)
   endif()
-  set(GA_FORTRAN_ACCESS_INDEX integer*8)
+  set(GA_ACCESS_INDEX_TYPE integer*8)
 else()
-  set(GA_FORTRAN_ACCESS_INDEX integer*4)
+  set(GA_ACCESS_INDEX_TYPE integer*4)
 endif()
 # set (CM_BLAS_SIZE ${CM_SIZEOF_F77_INTEGER})
 
@@ -275,88 +337,3 @@
                 ${CMAKE_CURRENT_BINARY_DIR}/ma/matypes.h )
 CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/mafdecls.fh.in
                 ${CMAKE_CURRENT_BINARY_DIR}/ma/mafdecls.fh )
-CONFIGURE_FILE( ${CMAKE_CURRENT_SOURCE_DIR}/cmake/global.fh.in
-                ${CMAKE_CURRENT_BINARY_DIR}/global/src/global.fh )
-
-if (ENABLE_FORTRAN)
-  add_custom_command(
-    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/config.fh
-    COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.h" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/config.fh" -P ${PROJECT_SOURCE_DIR}/tools/config_fh_from_h.cmake DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
-    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.h
-  )
-  add_custom_target(
-    GenerateConfigFH ALL
-    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/config.fh
-  )
-  set_source_files_properties(
-    ${CMAKE_CURRENT_BINARY_DIR}/config.fh
-    PROPERTIES GENERATED TRUE
-  )
-endif()
-
-include_directories(AFTER ${MPI_INCLUDE_PATH})
-add_definitions (-DHAVE_CONFIG_H -DOMPI_SKIP_MPICXX)
-
-set(THREADS_PREFER_PTHREAD_FLAG ON)
-find_package(Threads REQUIRED)
-list(APPEND GA_EXTRA_LIBS ${CMAKE_THREAD_LIBS_INIT})
-
-if(NOT ENABLE_FORTRAN OR BUILD_SHARED_LIBS)
-  if(NOT MSVC)
-    list(APPEND GA_EXTRA_LIBS m)
-  endif()
-endif()
-if(NOT "${CMAKE_HOST_SYSTEM_NAME}" STREQUAL "Darwin")
-  if(NOT MSVC)
-    list(APPEND GA_EXTRA_LIBS rt)
-  endif()
-endif()
-
-if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
-  add_compile_options(-fno-aggressive-loop-optimizations)
-endif()
-
-if(ENABLE_BLAS)
-  list(APPEND GA_EXTRA_LIBS ${linalg_lib})
-  add_compile_options(${BLAS_COMPILE_OPTIONS})
-  add_compile_definitions(${BLAS_COMPILE_DEFINITIONS})
-  #include_directories(${BLAS_INCLUDE_DIRS})
-endif()
-
-if(ENABLE_PROFILING)
-  set(ga_profiler $<TARGET_OBJECTS:ga_tools>)
-endif()
-
-if(ENABLE_BLAS)
-  include_directories(LinAlg/lapack+blas)
-else()
-  set(ga_ref_blas $<TARGET_OBJECTS:linalg>)
-endif()
-
-add_library(ga
-  $<TARGET_OBJECTS:ma>
-  $<TARGET_OBJECTS:dra>
-  $<TARGET_OBJECTS:eaf>
-  $<TARGET_OBJECTS:elio>
-  $<TARGET_OBJECTS:sf>
-  $<TARGET_OBJECTS:gaf2c>
-  $<TARGET_OBJECTS:armci_comex>
-  $<TARGET_OBJECTS:ga_src>
-  ${ga_ref_blas}
-  ${ga_profiler}
-)
-add_library(GlobalArrays::ga ALIAS ga)
-
-set (CMAKE_REQUIRED_LIBRARIES lapack blas)
-target_link_libraries(ga PUBLIC ${GA_EXTRA_LIBS})
-target_include_directories(ga
-  INTERFACE
-    $<INSTALL_INTERFACE:include>
-    $<INSTALL_INTERFACE:include/ga>
-)
-if(ENABLE_BLAS)
-  target_include_directories(ga
-    INTERFACE
-      $<INSTALL_INTERFACE:${BLAS_INCLUDE_DIRS}>
-  )
-  target_compile_options(ga
