=== debian/changelog ===
ga (5.9-2) unstable; urgency=medium

  * Team upload.
  * replace debian patch eaf_common_Integer.patch with
    hotfix_32bit_int.patch to apply upstream patches from hotfix/5.9.1
    branch fixing integers for 32-bit systems. See upstream Issue#352.

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Feb 2025 00:20:35 +0100

ga (5.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies debian patches dsygv_int32_PR317.patch
      and scalapack_32bit_PR315.patch
  * update debian/copright to remove files removed upstream
  * update debian patch skip_failing_tests.patch to skip testsparse,
    which has incompatible definitions, see upstream Issue#361.
  * debian patch gcc15_gnu17_PR360.patch applies upstream PR#360
    to enable building with gcc-15 by specifying -std=gnu17.
    Closes: #1096668.
  * drop redundant debian patch fix_ga_target.patch

 -- Drew Parsons <dparsons@debian.org>  Wed, 19 Feb 2025 20:06:29 +0100

ga (5.8.2-11) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip threadsafec
    on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Fri, 27 Sep 2024 02:55:51 +0200

ga (5.8.2-10) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip thread_perf_strided
    on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Sep 2024 17:15:49 +0200

ga (5.8.2-9) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip thread_perf_contig
    on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Sep 2024 09:14:54 +0200

ga (5.8.2-8) unstable; urgency=medium

  * Team upload.
  * debian/patches/skip_failing_tests.patch: skip the lennard-jones
    example on mips64el (times out with mpich)

 -- Drew Parsons <dparsons@debian.org>  Wed, 25 Sep 2024 16:50:19 +0200

ga (5.8.2-7) unstable; urgency=medium

  * Team upload.
  * debian patch skip_failing_tests.patch
    - skip jacobi on mips64el  mips64el times out (on mpich) after
      ghosts, jacobi is the next.
    - drop *_SOURCES for skipped tests

 -- Drew Parsons <dparsons@debian.org>  Tue, 24 Sep 2024 11:26:34 +0200

ga (5.8.2-6) unstable; urgency=medium

  * Team upload.
  * debian patch skip_failing_tests.patch skips tests which fail on
    the build environment. The tests pass when run manually.
    - mir_perf2, perfmod, perform, perf fail with "requires 4 GA processes"
      (but the tests are configured with -np 4)
    - sprsmatmult, stride have memory errors

 -- Drew Parsons <dparsons@debian.org>  Mon, 23 Sep 2024 16:00:30 +0200

ga (5.8.2-5) unstable; urgency=medium

  * Team upload.
  * debian/rules: run dh_auto_* build rules using --builddirectory not
    --sourcedirectory to get out-of-source builds
  * debian patch eaf_common_Integer.patch defines eaf handle and index
    using Integer rather than long for compatibility with MA.
    See upstream Issue#352.

 -- Drew Parsons <dparsons@debian.org>  Sat, 21 Sep 2024 19:20:42 +0200

ga (5.8.2-4) unstable; urgency=medium

  * Team upload.
  * only build against openmpi or mpich where supported by the arch.
    Prepare for openmpi 5 dropping 32-bit arch support.
    mpi-default-dev already declares that openmpi is not supported on
    32-bit arches.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 18 Sep 2024 16:22:07 +0200
