=== debian/control ===
--- 
+++ 
@@ -9,12 +9,13 @@
                libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
                liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
                libscalapack-mpi-dev (>= 2),
-               libscalapack-openmpi-dev (>= 2),
+               libscalapack-openmpi-dev (>= 2) [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
                libscalapack-mpich-dev (>= 2),
                mpi-default-dev,
-               libopenmpi-dev, libmpich-dev,
+               libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
+               libmpich-dev,
                openssh-client
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: http://hpc.pnl.gov/globalarrays/
 Vcs-Browser: https://salsa.debian.org/debichem-team/ga
 Vcs-Git: https://salsa.debian.org/debichem-team/ga.git
