## ga 5.9.1

=== debian/changelog ===
ga (5.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - applies debian patches gcc15_gnu17_PR360.patch
      and hotfix_32bit_int.patch

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Mar 2025 00:51:24 +0100
